document.addEventListener('DOMContentLoaded', function() {
var cities = [
  { nimi: 'Helsinki', pituuspiiri: 24.9417, leveyspiiri: 60.1699 },
  { nimi: 'Pariisi', pituuspiiri: 2.3522, leveyspiiri: 48.8566 },
  { nimi: 'Rooma', pituuspiiri: 12.4964, leveyspiiri: 41.9028 },
  { nimi: 'New York', pituuspiiri: -74.0060, leveyspiiri: 40.7128 },
  { nimi: 'Tokio', pituuspiiri: 139.6917, leveyspiiri: 35.6895 },
  { nimi: 'Lontoo', pituuspiiri: -0.1276, leveyspiiri: 51.5074 },
  { nimi: 'Rio de Janeiro', pituuspiiri: -43.1729, leveyspiiri: -22.9068 },
  { nimi: 'Istanbul', pituuspiiri: 28.9784, leveyspiiri: 41.0082 },
  { nimi: 'Sydney', pituuspiiri: 151.2093, leveyspiiri: -33.8688 },
  { nimi: 'Dubai', pituuspiiri: 55.2708, leveyspiiri: 25.2048 },
  { nimi: 'Shanghai', pituuspiiri: 121.4737, leveyspiiri: 31.2304 },
  { nimi: 'Moskova', pituuspiiri: 37.6176, leveyspiiri: 55.7558 },
  { nimi: 'Kairo', pituuspiiri: 31.2357, leveyspiiri: 30.0444 },
  { nimi: 'Hongkong', pituuspiiri: 114.1694, leveyspiiri: 22.3193 },
  { nimi: 'Toronto', pituuspiiri: -79.3832, leveyspiiri: 43.6532 },
  { nimi: 'Rio de Janeiro', pituuspiiri: -43.1729, leveyspiiri: -22.9068 },
  { nimi: 'Buenos Aires', pituuspiiri: -58.3816, leveyspiiri: -34.6037 },
  { nimi: 'Mumbai', pituuspiiri: 72.8777, leveyspiiri: 19.0760 },
  { nimi: 'Kapkaupunki', pituuspiiri: 18.4241, leveyspiiri: -33.9249 },
  { nimi: 'Berliini', pituuspiiri: 13.4050, leveyspiiri: 52.5200 },
  { nimi: 'Seoul', pituuspiiri: 126.9780, leveyspiiri: 37.5665 },
  { nimi: 'S\u00E3o Paulo', pituuspiiri: -46.6333, leveyspiiri: -23.5505 },
  { nimi: 'Bangkok', pituuspiiri: 100.5167, leveyspiiri: 13.7563 },
  { nimi: 'Amsterdam', pituuspiiri: 4.8952, leveyspiiri: 52.3702 },
  { nimi: 'Mexico City', pituuspiiri: -99.1332, leveyspiiri: 19.4326 },
  { nimi: 'Los Angeles', pituuspiiri: -118.2437, leveyspiiri: 34.0522 },
  { nimi: 'Delhi', pituuspiiri: 77.1025, leveyspiiri: 28.7041 },
  { nimi: 'Lima', pituuspiiri: -77.0428, leveyspiiri: -12.0464 },
  { nimi: 'Kairo', pituuspiiri: 31.2357, leveyspiiri: 30.0444 },
  { nimi: 'Riika', pituuspiiri: 24.1052, leveyspiiri: 56.9496 },
  { nimi: 'Melbourne', pituuspiiri: 144.9631, leveyspiiri: -37.8136 },
  { nimi: 'Barcelona', pituuspiiri: 2.1734, leveyspiiri: 41.3851 },
  { nimi: 'K\u00F6\u00F6penhamina', pituuspiiri: 12.5683, leveyspiiri: 55.6761 },
  { nimi: 'Vancouver', pituuspiiri: -123.1207, leveyspiiri: 49.2827 },
  { nimi: 'Wien', pituuspiiri: 16.3738, leveyspiiri: 48.2082 },
  { nimi: 'San Francisco', pituuspiiri: -122.4194, leveyspiiri: 37.7749 },
  { nimi: 'Bangkok', pituuspiiri: 100.5167, leveyspiiri: 13.7563 },
  { nimi: 'Budapest', pituuspiiri: 19.0402, leveyspiiri: 47.4979 },
  { nimi: 'Oslo', pituuspiiri: 10.7522, leveyspiiri: 59.9139 },
  { nimi: 'Dublin', pituuspiiri: -6.2603, leveyspiiri: 53.3498 }    
];

  var selectedCities = [];
  var remainingCities = [];

  var startGameButton = document.getElementById('start-game');
  var instructionsButton = document.getElementById('instructions');
  var closeButton = document.getElementById('close-popup');

  var clockElement = document.getElementById('clock');
  var time = 180;
  var timer;
const lopetaNappi = document.getElementById('lopetaNappi');
lopetaNappi.addEventListener('click', finishGame);
  var gameContainer = document.getElementById('game-container');

  var instructionsFrame = document.getElementById('instructions-frame');
  let lyhinReitti = [];
  let lyhinPituus = Number.MAX_SAFE_INTEGER;
  let pelaajanPituus = Number.MAX_SAFE_INTEGER;
  
  
  startGameButton.addEventListener('click', function() {
    startGameButton.style.display = 'none';
    instructionsButton.style.display = 'none';
    startGame();
  });

  const distanceDisplay = document.getElementById("distance-display");
  distanceDisplay.style.fontSize = "34px"; // Aseta haluttu fonttikoko
  
  function createCityOrder() {
    // Arvo 10 satunnaista kaupunkia
    var randomCities = getRandomCities(10);

    // Lisää valitut satunnaiset kaupungit kaupunkilistaan
    for (var i = 0; i < randomCities.length; i++) {
      selectedCities.push(cities[randomCities[i]]);
    }

    // Luo lista jäljellä olevista kaupungeista
    for (var j = 1; j < cities.length; j++) {
      if (!selectedCities.includes(cities[j])) {
        remainingCities.push(cities[j]);
      }
    }
  }

// Funktio, joka arpoo satunnaisen kaupungin, poissulkee Helsingin
function arvoSatunnainenKaupunki() {
  var mahdollisetKaupungit = cities.filter(function(kaupunki) {
    return kaupunki.nimi !== 'Helsinki';
  });

  var satunnainenIndeksi = Math.floor(Math.random() * mahdollisetKaupungit.length);
  var satunnainenKaupunki = mahdollisetKaupungit[satunnainenIndeksi];
  mahdollisetKaupungit.splice(satunnainenIndeksi, 1); // Poistetaan valittu kaupunki mahdollisista kaupungeista
  return satunnainenKaupunki;
}
function getRandomCities(num) {
// Arvotaan 10 eri kaupunkia
var valitutKaupungit = [];
while (valitutKaupungit.length < num) {
  var satunnainenKaupunki = arvoSatunnainenKaupunki();
  if (!valitutKaupungit.some(function(kaupunki) {
    return kaupunki.nimi === satunnainenKaupunki.nimi;
  })) {
    valitutKaupungit.push(satunnainenKaupunki);
  }
}
return valitutKaupungit;
}
// Funktio reitin pituuden laskemiseksi Haversine-kaavalla
function laskeEtaisyys(lat1, lon1, lat2, lon2) {
  // Maapallon säde kilometreissä
  const radius = 6371.0;

  // Muunna latitudet ja longitudet radiaaneiksi
  const lat1Rad = toRadians(lat1);
  const lon1Rad = toRadians(lon1);
  const lat2Rad = toRadians(lat2);
  const lon2Rad = toRadians(lon2);

  // Haversine-kaavan mukainen etäisyys lasketaan
  const dlon = lon2Rad - lon1Rad;
  const dlat = lat2Rad - lat1Rad;
  const a = Math.sin(dlat / 2) ** 2 + Math.cos(lat1Rad) * Math.cos(lat2Rad) * Math.sin(dlon / 2) ** 2;
  const c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1 - a));
  const distance = radius * c;

  return distance;
}

// Apufunktio asteen muuttamiseksi radiaaneiksi
function toRadians(degrees) {
  return (degrees * Math.PI) / 180;
}
// Funktio reitin pituuden laskemiseksi
function calculateRouteLength() {
  const listItems = document.querySelectorAll("#game-container li");
  const valittuReitti = [];

  for (let i = 0; i < listItems.length; i++) {
    const cityName = listItems[i].getAttribute("data-city");
    const city = selectedCities.find(city => city.nimi === cityName);
	
    if (city) {
      valittuReitti.push(city);
    }
  }

  let totalDistance = 0;

  for (let i = 0; i < valittuReitti.length - 1; i++) {
    const city1 = valittuReitti[i];
    const city2 = valittuReitti[i + 1];

    const distance = laskeEtaisyys(city1.leveyspiiri, city1.pituuspiiri, city2.leveyspiiri, city2.pituuspiiri);
    totalDistance += distance;
  }

  //console.log("Reitti:", valittuReitti);
  //console.log("totalDistance:", totalDistance);
  
  // Päivitä haluttu elementti sisältämään reitin etäisyys isolla fontilla

  distanceDisplay.textContent = "Reittisi pituus: " + Math.floor(totalDistance) + " km.";
  pelaajanPituus = totalDistance;  
  
}



  function createSortableList() {
	  selectedCities = getRandomCities(10);
   var listContainer = document.getElementById('list-container');
    listContainer.setAttribute('id', 'sortable-list');

     var listItem = document.createElement('li');
      listItem.setAttribute('class', 'sortable-item2');
      listItem.textContent = cities[0].nimi;
      listItem.setAttribute('data-city', cities[0].nimi); // Lisää data-city-attribuutti ja sen arvo
      listContainer.appendChild(listItem);    
    
    for (var i = 0; i < selectedCities.length; i++) {
      var listItem = document.createElement('li');
      listItem.setAttribute('class', 'sortable-item');
      listItem.textContent = selectedCities[i].nimi;
       listItem.setAttribute('data-city', selectedCities[i].nimi); // Lisää data-city-attribuutti ja sen arvo
      listContainer.appendChild(listItem);
    }
    
     var listItem = document.createElement('li');
      listItem.setAttribute('class', 'sortable-item2');
      listItem.textContent = cities[0].nimi;
      listItem.setAttribute('data-city', cities[0].nimi); // Lisää data-city-attribuutti ja sen arvo
      listContainer.appendChild(listItem);       
    

    gameContainer.appendChild(listContainer);

    new Sortable(listContainer, {
      animation: 150
    });
    
  
  }


  function startGame() { //********************************************************
const aloitaPeliNappi = document.getElementById("aloitaPeliNappi");
aloitaPeliNappi.style.display = "block";
aloitaPeliNappi.addEventListener("click", function() {
  location.reload();
});
lopetaNappi.style.display = 'inline-block';
    createCityOrder();
    createSortableList();
    calculateRouteLength();
    
// Lisää tapahtumankäsittelijä sortable listiin
const listContainer = document.getElementById("game-container");

listContainer.addEventListener("change", calculateRouteLength);    
    
    
    startTimer();
  }
  function startTimer() {
    timer = setInterval(function() {
      time--;
      var minutes = Math.floor(time / 60);
      var seconds = time % 60;
      clockElement.textContent = padZero(minutes) + ':' + padZero(seconds);
		getProgramOrder();
      if (time === 0) {
        clearInterval(timer);
        finishGame();
      }
    }, 1000);
  }

  function padZero(number) {
    return (number < 10) ? '0' + number : number;
  }

  function finishGame() {
	  	  // Päivitä haluttu elementti sisältämään lyhimmän reitin kaupunkien nimet
  const ohjelmanReittiElement = document.getElementById("ohjelmanReitti");

  
  const kaupunkienNimet = lyhinReitti.map(city => city.nimi);
  var message = ''; // Alustetaan tyhjä merkkijono
 if (lyhinPituus === pelaajanPituus) {
  message += "Tasapeli! ";
} else if (lyhinPituus < pelaajanPituus) {
  message += "Havisit talla kertaa :( ";
} else {
  message += "Onneksi olkoon! Voitit :) ";
} 
  
  message += "Ohjelman valitsema reitti: " + kaupunkienNimet.join(", ") + ". Reitin pituus on " + Math.floor(lyhinPituus) + " km";

 alert(message);
     
  }

  function getProgramOrder() {
	  //console.log('Huhuu täällä ollaan!');
    // Funktio kaupunkien järjestyksen sekoittamiseksi
	function shuffleArray(array) {
	  for (let i = array.length - 1; i > 0; i--) {
	    const j = Math.floor(Math.random() * (i + 1));
	    [array[i], array[j]] = [array[j], array[i]];
	  }
	  return array;
	}
	
// Lisää Helsinki taulukon alkuun ja loppuun
selectedCities.unshift({ nimi: "Helsinki", pituuspiiri: 24.9384, leveyspiiri: 60.1699 });
selectedCities.push({ nimi: "Helsinki", pituuspiiri: 24.9384, leveyspiiri: 60.1699 });

// Sekoita kaupunkien järjestys paitsi Helsinki
const shuffledCities = shuffleArray(selectedCities.slice(1, -1));

// Luo sattumanvarainen reitti
const sattumallinenReitti = [selectedCities[0], ...shuffledCities, selectedCities[selectedCities.length - 1]];	
	


// Laske sattumallisen reitin pituus
function calculateRouteLength(route) {
  let totalDistance = 0;

  for (let i = 0; i < route.length - 1; i++) {
    const city1 = route[i];
    const city2 = route[i + 1];

    const distance = laskeEtaisyys(city1.leveyspiiri, city1.pituuspiiri, city2.leveyspiiri, city2.pituuspiiri);
    totalDistance += distance;
  }

  return totalDistance;
}
function tarkistaSattumallinenReitti(sattumallinenReitti) {
  // Tarkista, että Helsinki on vain ensimmäisenä ja viimeisenä paikassa
  const oikeaReitti = [sattumallinenReitti[0], ...sattumallinenReitti.slice(1, -1).filter(city => city.nimi !== 'Helsinki'), sattumallinenReitti[sattumallinenReitti.length - 1]];
  
  return oikeaReitti;
}

// Generoi ja tallenna sattumallinen reitti
function generateRandomRoute() {
  // Sekoita kaupunkien järjestys paitsi Helsinki
  const shuffledCities = shuffleArray(selectedCities.slice(1, -1));

  // Luo sattumallinen reitti
  let sattumallinenReitti = [selectedCities[0], ...shuffledCities, selectedCities[selectedCities.length - 1]];
sattumallinenReitti =	tarkistaSattumallinenReitti(sattumallinenReitti);
  // Laske sattumallisen reitin pituus
 
	const reitinPituus = calculateRouteLength(sattumallinenReitti);
  // Päivitä lyhin reitti, jos uusi reitti on lyhyempi
  //console.log(lyhinPituus);
  if (reitinPituus < lyhinPituus) {
    lyhinReitti = sattumallinenReitti;
    //console.log(lyhinReitti);
    lyhinPituus = reitinPituus;
    
  }
}
generateRandomRoute();
	
}

}

);
